// Auto-generated file. Do not edit!
//   Template: src/f16-rminmax/neonfp16arith.c.in
//   Generator: tools/xngen
//
// Copyright 2023 Google LLC
//
// This source code is licensed under the BSD-style license found in the
// LICENSE file in the root directory of this source tree.

#include <assert.h>

#include <arm_neon.h>

#include "xnnpack/common.h"
#include "xnnpack/reduce.h"


void xnn_f16_rminmax_ukernel__neonfp16arith_u64_acc4(
    size_t batch,
    const void* input,
    void* output,
    const struct xnn_f16_default_params params[restrict XNN_MIN_ELEMENTS(1)]) XNN_OOB_READS
{
  assert(batch != 0);
  assert(batch % sizeof(uint16_t) == 0);
  assert(input != NULL);
  assert(output != NULL);

  const uint16_t* i = (const uint16_t*) input;
  uint16_t* o = (uint16_t*) output;
  float16x8_t vmin0 = vreinterpretq_f16_u16(vld1q_dup_u16(i));
  float16x8_t vmax0 = vmin0;
  float16x8_t vmin1 = vmin0;
  float16x8_t vmax1 = vmax0;
  float16x8_t vmin2 = vmin0;
  float16x8_t vmax2 = vmax0;
  float16x8_t vmin3 = vmin0;
  float16x8_t vmax3 = vmax0;
  for (; batch >= 64 * sizeof(uint16_t); batch -= 64 * sizeof(uint16_t)) {
    const float16x8_t vt0 = vreinterpretq_f16_u16(vld1q_u16(i)); i += 8;
    const float16x8_t vt1 = vreinterpretq_f16_u16(vld1q_u16(i)); i += 8;
    const float16x8_t vt2 = vreinterpretq_f16_u16(vld1q_u16(i)); i += 8;
    const float16x8_t vt3 = vreinterpretq_f16_u16(vld1q_u16(i)); i += 8;
    const float16x8_t vt4 = vreinterpretq_f16_u16(vld1q_u16(i)); i += 8;
    const float16x8_t vt5 = vreinterpretq_f16_u16(vld1q_u16(i)); i += 8;
    const float16x8_t vt6 = vreinterpretq_f16_u16(vld1q_u16(i)); i += 8;
    const float16x8_t vt7 = vreinterpretq_f16_u16(vld1q_u16(i)); i += 8;

    vmin0 = vminq_f16(vmin0, vt0);
    vmax0 = vmaxq_f16(vmax0, vt0);
    vmin1 = vminq_f16(vmin1, vt1);
    vmax1 = vmaxq_f16(vmax1, vt1);
    vmin2 = vminq_f16(vmin2, vt2);
    vmax2 = vmaxq_f16(vmax2, vt2);
    vmin3 = vminq_f16(vmin3, vt3);
    vmax3 = vmaxq_f16(vmax3, vt3);
    vmin0 = vminq_f16(vmin0, vt4);
    vmax0 = vmaxq_f16(vmax0, vt4);
    vmin1 = vminq_f16(vmin1, vt5);
    vmax1 = vmaxq_f16(vmax1, vt5);
    vmin2 = vminq_f16(vmin2, vt6);
    vmax2 = vmaxq_f16(vmax2, vt6);
    vmin3 = vminq_f16(vmin3, vt7);
    vmax3 = vmaxq_f16(vmax3, vt7);
  }
  vmin0 = vminq_f16(vmin0, vmin1);
  vmax0 = vmaxq_f16(vmax0, vmax1);
  vmin2 = vminq_f16(vmin2, vmin3);
  vmax2 = vmaxq_f16(vmax2, vmax3);
  vmin0 = vminq_f16(vmin0, vmin2);
  vmax0 = vmaxq_f16(vmax0, vmax2);
  for (; batch >= 8 * sizeof(uint16_t); batch -= 8 * sizeof(uint16_t)) {
    const float16x8_t vt = vreinterpretq_f16_u16(vld1q_u16(i)); i += 8;
    vmin0 = vminq_f16(vmin0, vt);
    vmax0 = vmaxq_f16(vmax0, vt);
  }
  float16x4_t vmin_lo = vmin_f16(vget_low_f16(vmin0), vget_high_f16(vmin0));
  float16x4_t vmax_lo = vmax_f16(vget_low_f16(vmax0), vget_high_f16(vmax0));

  if (XNN_UNLIKELY(batch != 0)) {
    const float16x8_t vt = vreinterpretq_f16_u16(vld1q_u16(i));
    float16x4_t vt_lo = vget_low_f16(vt);
    if (batch & (4 * sizeof(uint16_t))) {
      vmin_lo = vmin_f16(vmin_lo, vt_lo);
      vmax_lo = vmax_f16(vmax_lo, vt_lo);
      vt_lo = vget_high_f16(vt);
    }
    if (batch & (2 * sizeof(uint16_t))) {
      vmin_lo = vmin_f16(vmin_lo, vext_f16(vmin_lo, vt_lo, 2));
      vmax_lo = vmax_f16(vmax_lo, vext_f16(vmax_lo, vt_lo, 2));
      vt_lo = vext_f16(vt_lo, vt_lo, 2);
    }
    if (batch & (1 * sizeof(uint16_t))) {
      vmin_lo = vmin_f16(vmin_lo, vext_f16(vmin_lo, vt_lo, 1));
      vmax_lo = vmax_f16(vmax_lo, vext_f16(vmax_lo, vt_lo, 1));
    }
  }
  #if XNN_ARCH_ARM64 && defined(__GNUC__)
    *((__fp16*) o) = vminv_f16(vmin_lo);
  #else
    vmin_lo = vpmin_f16(vmin_lo, vmin_lo);
    vmin_lo = vpmin_f16(vmin_lo, vmin_lo);
    vst1_lane_u16(o, vreinterpret_u16_f16(vmin_lo), 0);
  #endif
  #if XNN_ARCH_ARM64 && defined(__GNUC__)
    *((__fp16*) o + 1) = vmaxv_f16(vmax_lo);
  #else
    vmax_lo = vpmax_f16(vmax_lo, vmax_lo);
    vmax_lo = vpmax_f16(vmax_lo, vmax_lo);
    vst1_lane_u16(o + 1, vreinterpret_u16_f16(vmax_lo), 0);
  #endif
}
